extension DateTimeExtension on DateTime {
  int get daysInMonth {
    final date = DateTime(year, month + 1, 0);
    return date.day;
  }

  int get weekOfYear {
    final jan1 = DateTime(year, 1, 1);
    final daysOffset = jan1.weekday - 1;
    final firstMonday = jan1
        .add(Duration(days: (daysOffset <= 3) ? -daysOffset : 7 - daysOffset));
    final currentDay = DateTime(year, month, day);
    final daysSinceFirstMonday = currentDay.difference(firstMonday).inDays;
    return (daysSinceFirstMonday / 7).ceil() + 1;
  }

  int get dayOfYear {
    final yearStart = DateTime(year, 1, 1);
    return difference(yearStart).inDays + 1;
  }
}
