extension MultiplyDuration on Duration {
  Duration multiply(int factor) {
    return Duration(seconds: inSeconds * factor);
  }

  Duration multiplyWithSign(Duration duration, int sign) {
    return Duration(
      days: duration.inDays * sign,
      hours: duration.inHours.remainder(24) * sign,
      minutes: duration.inMinutes.remainder(60) * sign,
      seconds: duration.inSeconds.remainder(60) * sign,
      milliseconds: duration.inMilliseconds.remainder(1000) * sign,
      microseconds: duration.inMicroseconds.remainder(1000) * sign,
    );
  }
}
